#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

using namespace std;

const int INF = 1e9+1;
const int maxV = 1e5+2;

int V, E, d[maxV], p[maxV];
bool u[maxV];
vector < pair<int, int> > g[100001]; /// FIRST: to; SECOND: length

void input_graph()
{
    cin >> V;
    char c;
    int cost;
    char str[V+1];
    for (int i = 1; i <= V; ++i){
        cin >> c;
        str[i] = c;
        for (int k = 1; k < i; ++k){
            char b = str[k];
            cost = abs(int(c-b))*(k-i);
            g[k].push_back({i, cost});
        }
    }
}

void dijkstra(int s)
{
    fill(d, d+V+1, INF);
    d[s] = 0;
    for (int i = 1; i <= V; ++i){
        int v = -1;
        for (int j = 1; j <= V; ++j){
            if ((u[j] == false) && (v == -1 || d[j] < d[v]))
                v = j;
        }
        if (d[v] == INF) break;
        u[v] = true;

        for (size_t j=0; j < g[v].size(); ++j){
            int to = g[v][j].first, len = g[v][j].second;
            if (d[v] + len < d[to]){
                d[to] = d[v] + len;
                p[to] = len;
            }
        }
    }
}


int main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio();
    freopen("strings.in", "r", stdin);
    freopen("strings.out", "w", stdout);

    input_graph();
    int s = 1;
    dijkstra(s);
    cout << -d[V];
    return 0;
}
