/* GCC */
#include <iostream>
#include <cstdio>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <iomanip>
#include <list>
#include <map>
#include <algorithm>

//#define maxVal=300000

using namespace std;

struct Combo
{
	int start = 0;
	int end = 0;
	int dist = 0;
};

vector<bool>  lamps  (300000);
vector<int> startOfCombo (300000);
map<int, Combo> combos; //comboByFirstPlace
map<int, int> distOfCombos; //len, amount
map<int, int>::iterator it; //iterator for showInfo
vector<int> resultsOfCombos(300000); //

int notFinded;
int N, E;
int eStart, eEnd;
int LampEvent;

void fillResultOfCombo(int a)
{
	if(!distOfCombos[a]){
		resultsOfCombos[a] = (a * (a + 1)) / 2;
	}
}

void recal()
{
	distOfCombos.clear();
	combos.clear();

	bool comboNow = false;
	Combo newCombo;

	for(int i = 0; i < N; i++){
		if(comboNow){
			if(!lamps[i]){
				comboNow = false;
				newCombo.end = i-1;
				newCombo.dist = newCombo.end - newCombo.start + 1;
				fillResultOfCombo(newCombo.dist);
				distOfCombos[newCombo.dist]++; //пополняет список комбинаций с такой длинной

				combos[i] = newCombo;
			}
		} else{
			if(lamps[i]){
				comboNow = true;
				newCombo.start = i;
			}
		}
	}

	if(comboNow){
		newCombo.end = N-1;
		newCombo.dist = newCombo.end - newCombo.start + 1;
		fillResultOfCombo(newCombo.dist);
		distOfCombos[newCombo.dist]++;

		combos[newCombo.start] = newCombo;
	}
}

void findFirstCombo()
{
	bool comboNow = false;
	Combo newCombo;

	for(int i = 0; i < N; i++){
		if(comboNow){
			if(!lamps[i]){
				comboNow = false;
				newCombo.end = i-1;
				newCombo.dist = newCombo.end - newCombo.start + 1;
				fillResultOfCombo(newCombo.dist);
				distOfCombos[newCombo.dist]++; //пополняет список комбинаций с такой длинной

				combos[i] = newCombo;
			}
		} else{
			if(lamps[i]){
				comboNow = true;
				newCombo.start = i;
			}
		}
	}

	if(comboNow){
		newCombo.end = N-1;
		newCombo.dist = newCombo.end - newCombo.start + 1;
		fillResultOfCombo(newCombo.dist);
		distOfCombos[newCombo.dist]++;
		combos[newCombo.start] = newCombo;
	}
}

void showInfo(){
	long long int result = 0;

	it = distOfCombos.begin();
	for(int i = 0; i < distOfCombos.size(); i++){
        
		result += (*it).second * resultsOfCombos[(*it).first];
        it++;
	}


	cout << result << endl;
}

int main ()
{
	freopen("lanterns.in", "r", stdin);
	freopen("lanterns.out", "w", stdout);

	cin >> N >> E;
	notFinded = N;

    string firstInput;
    cin >> firstInput;
	for(int i = 0; i < N; i++){
        if(firstInput[i] == '0') lamps[i] = false;
		else lamps[i] = true;
	}

	findFirstCombo();
	showInfo();


	bool isCreating = false;
	int newCreaded = 0;
	Combo currentCombo;
	
	for(int i = 0; i < E; i++){
		cin >> eStart >> eEnd >> LampEvent;
		eStart--;
		eEnd--;

		while(eStart <= eEnd){
			if(LampEvent) lamps[eStart] = LampEvent;

			eStart++;
		}

		recal();
		showInfo();
	}

	

	return 0;
}

/*

*/