/* GCC */
#include <iostream>
#include <stdio.h>

#define x first
#define y second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int inf = 1000000007;
const int maxn = 1000100;

int mas[maxn];

struct Node{
    Node* L, *R;
    int l, m, r, sz;
};

int f(int a) {
    return a*(a+1)/2;
}

Node* comb(Node* A, Node* B) {
    Node* res = new Node;
    res->L = A;
    res->R = B;
    if (A->r == A->sz)
        if (B->r == B->sz) {
            res->l = A->l + B->l;
            res->r = A->l + B->l;
            res->m = 0;
        } else {
            res->l = A->l + B->l;
            res->r = B->r;
            res->m = B->m;
        }
    else if (B->r == B->sz) {
            res->l = A->l;
            res->r = A->r + B->r;
            res->m = A->m;
        } else {
            res->l = A->l;
            res->r = B->r;
            res->m = B->m + A->m + f(A->r + B->l);
        }
    res->sz = A->sz + B->sz;
    return res;
}

void build(Node* &root, int l, int r) {
    root = new Node;
    if (l == r) {
        root->sz = 1;
        root->m = 0;
        root->l = root->r = mas[l];
    } else {
        int m = (l+r)/2;
        build(root->L, l, m);
        build(root->R, m+1, r);
        root = comb(root->L, root->R);
    }
}

void update(Node* &root, int l, int r, int ql, int qr, bool c) {
    if (l == ql && r == qr) {
        root->m = 0;
        root->l = root->r = c*(r-l+1);
    } else {
        int m = (l+r)/2;
        if (qr <= m)
            update(root->L, l, m, ql, qr, c);
        else if (ql > m)
            update(root->R, m+1, r, ql, qr, c);
        else {
            update(root->L, l, m, ql, m, c);
            update(root->R, m+1, r, m+1, qr, c);
        }
        root = comb(root->L, root->R);
        //cout << " " << l << " " << r << " {" << root->l << ", " << root->m << ", " << root->r << ", " << root->sz << "}" << endl;
    }
}

int main() {
    freopen("lanterns.in", "r", stdin);freopen("lanterns.out", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;
    char c;
    for (int i = 1; i <= n; i++) {
        cin >> c;
        mas[i] = (c == '1');
    }
    Node* root;
    build(root, 1, n);
    cout << f(root->l) + root->m + f(root->r) << "\n";
    int L, R;
    bool C;
    while (q--) {
        cin >> L >> R >> C;
        update(root, 1, n, L, R, C);
        if (root->l == root->sz)
            cout << f(root->l) + root->m << "\n";
        else
            cout << f(root->l) + root->m + f(root->r) << "\n";
    }
    return 0;
}
/*
7 4
1100101
4 6 1
3 6 0
3 4 1
5 7 1
*/
