""" Python 3 """

import itertools

inp = open("lanterns.in").readlines()
out = open("lanterns.out", "w")

spl = inp[0].split(" ")
lamps, events = int(spl[0]), int(spl[1])
lamps_range = range(lamps)
states = [0] * lamps
spl = list(inp[1])
for i in lamps_range:
	if int(spl[i]) == 1:
		states[i] = 1

total_segments = int(lamps * (lamps + 1) / 2)
unworking_segments = []

# generate unworking segments list
# single
unworking_singles = [1] * lamps
for i in lamps_range:
	if states[i] == 1:
		unworking_singles[i] = 0
# row
for c in itertools.combinations(lamps_range, 2):
	left, right = c
	if sum(states[left:right+1]) != (right-left+1):
		unworking_segments.append(c)

out.write(str(total_segments - len(unworking_segments) - sum(unworking_singles)) + '\n')

# simulate events
for event in range(events):
	spl = inp[2 + event].replace("  ", " ").split(" ")
	left, right, state = int(spl[0]), int(spl[1]), int(spl[2])
	for i in range(left, right+1):
		states[i-1] = state
		if state == 1 and unworking_singles[i-1] == 1:
			unworking_singles[i-1] = 0
	# remove working segments
	n_us = []
	for segment in unworking_segments:
		sl, sr = segment
		if sum(states[sl:sr+1]) != (sr-sl+1):
			n_us.append(segment)
	unworking_segments = n_us
	out.write(str(total_segments - len(unworking_segments) - sum(unworking_singles)) + '\n')

out.close()